package Modules;

import Controll.GuildController;
import Controll.SuperModule;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.events.GenericEvent;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.awt.Color;


public class LoveCalc extends SuperModule{

    private final Logger logger = LoggerFactory.getLogger(LoveCalc.class);
    public static final String command = "lovecalc";

    /**
     * Construcker of a Module
     *
     * @param guildController Guild where Module is used, each guild get its own Module
     */
    public LoveCalc(GuildController guildController) {
        super(command, guildController);
    }

    @Override
    public String getCommand() {
        return command;
    }

    @Override
    public String getDescription() {
        return "Mention two users and Amour will tell you his probability to hit those two with his arrows";
    }

    @Override
    public void execute(GenericEvent event) {

        if (event instanceof GuildMessageReceivedEvent){

            GuildMessageReceivedEvent thisEvent = (GuildMessageReceivedEvent) event;

            if (!isCommand(thisEvent.getMessage()))
                return;

            logger.debug(command + "triggered");

            EmbedBuilder eb = new EmbedBuilder();

            int love = (int)((thisEvent.getMessage().getMentionedUsers().get(0).getIdLong() + thisEvent.getMessage().getMentionedUsers().get(1).getIdLong()) % 100);
            System.out.println("Do Lovecalc! love is: " + love);

            eb.setAuthor("Amour");
            eb.setColor(new Color((100-love)/100f,(love)/100f,0));
            eb.setTitle("chance that Amours arrows will hit " + thisEvent.getMessage().getMentionedUsers().get(0).getName()
                    + " and " + thisEvent.getMessage().getMentionedUsers().get(1).getName() + ":" );
            eb.setDescription(love + "%");

            thisEvent.getChannel().sendMessage(eb.build()).queue();
        }
    }

    @Override
    public String showSettings() {
        return null;
    }
}
